﻿using Dalamud.IoC;
using Dalamud.Plugin;
using Dalamud.Plugin.Services;

namespace TextBoxStyler {
    // ReSharper disable once ClassNeverInstantiated.Global
    public class Plugin : IDalamudPlugin {
        internal static string Name => "Text Box Styler";

        [PluginService]
        internal DalamudPluginInterface Interface { get; private init; } = null!;

        [PluginService]
        internal ICommandManager CommandManager { get; private init; } = null!;

        internal PluginConfiguration Config { get; }
        internal PluginUi Ui { get; }
        private Styler Styler { get; }
        private Commands Commands { get; }

        public Plugin() {
            this.Config = this.Interface.GetPluginConfig() as PluginConfiguration ?? new PluginConfiguration();
            this.Config.Initialise(this);

            this.Styler = new Styler(this);
            this.Ui = new PluginUi(this);
            this.Commands = new Commands(this);
        }

        public void Dispose() {
            this.Commands.Dispose();
            this.Ui.Dispose();
            this.Styler.Dispose();
        }
    }
}
